;*******************************************************************************
;*                        Ledszalag fnyer? szablyz                          *
;*******************************************************************************	

	LIST	P=PIC10F322	; lista megad??sa
	RADIX	hex		; alap?rtelmezet sz??mrendszer megad??sa
	#include "p10F322.inc"


 __CONFIG _FOSC_INTOSC & _BOREN_OFF & _WDTE_ON & _MCLRE_OFF & _LVP_OFF & _LPBOR_OFF
 
    CBLOCK  0x40
    WAIT
    IDO
    CIKLUS
    ADAT1
    ADAT2
    ADAT3
    ADAT4
    KONTROL1
    KONTROL2
    ENDC
    
  
 
    org	    0x0000
    nop
    


INICIALIZALAS    
    CLRF    LATA
    CLRF    ANSELA
    CLRF    ADCON
    MOVLW   B'00001010'
    MOVWF   TRISA       ;RA3 s RA1 bemenetnek van lltva.
    MOVLW   B'00001010'
    MOVWF   WPUA        ;RA3 s RA1 bels? felhz ellenlls bekapcsolva.
    MOVLW   B'00100000'
    MOVWF   OSCCON      ;Oszcilltor 500KHz-re lltva
    MOVLW   B'00000001' ;Itt van engedlyezve a WPUA, valamint belltva 
    MOVWF   OPTION_REG  ;Timer 0 1:4-es el?osztsa
    MOVLW   B'00000100'
    MOVWF   T2CON       ;Timer 2 bekapcsolsa el? s ut oszt nlkl
    MOVLW   .249
    MOVWF   PR2         ;PWM peridus idejnek belltsa 500Hz-re
    MOVLW   B'10000000'
    MOVWF   PWM1CON     ;PWM 1 kivlasztsa
    MOVLW   .60
    CLRF    PWM1DCL     ;Kitltsi tnyez? belltsa. A LED-ek fnyereje llt-
    MOVWF   PWM1DCH     ;hat itt be a tpfeszltsg mrtknek megfelel?en.
    MOVLW   B'00100011'
    MOVWF   WDTCON      ;Watchdog timer belltsa 2 percre
    ;---------------
MAIN                ;-------------------Alaphelyzet, adat vtele-------------
    CLRWDT              ;Alaphelyzetben, amg a lmpa felkapcsolsa nem trtnt
    BCF	    INTCON,2    ;meg, a watchdog szmllja folyamatosan trlsre 
    MOVLW   .32         ;kerl. Timer 0 id?zt? feladata, hogy a bejv? jelre
    MOVWF   CIKLUS      ;val vrakozst kb 8 milisecenknt megszaktssa s
VETEL                   ;a vteli ciklust jra indtssa. Ijenkor trli a 
    BTFSC   INTCON,2    ;watchdog timert is. gy egy esetleges zavarjel, vagy
    GOTO    MAIN        ;hibs vtel esetn dobja az adatot s jat vr.
    BTFSC   PORTA,1     ;Az ad kt ads kztti vrakozsa is ezt a clt 
    GOTO    VETEL       ;szolglja, hogy ha hiba volt a vtelben, a vev? a 
    CLRF    TMR0        ;kvetkez? adatcsomagot mr tudja fogadni. Vtel 
    BCF	    INTCON,2    ;megkezdsekor trlsre kerl Timer 0 szmllja, hogy
    MOVLW   .16         ;vtel kzben nehogy jra indtsson.
    MOVWF   WAIT        ;Ha jtt be jel, vrakozik usec-et, majd a ngy adat-
    DECFSZ  WAIT        ;byte bitjeit a 4. byteval kezdve egyms utn eggyel  
    GOTO    $-1         ;balra tolja. Ezutn trli a 4. adatbyte 0-s bitjt.
    RLF	    ADAT4       ;majd megvizsglja az adatvonalat. Ha az adatvonal 1
    RLF	    ADAT3       ;akkor a 4. byte 0-s bitjt is egybe lltja.
    RLF	    ADAT2       ;Ezutn addig figyeli az adatvonalat, mg az 1-be nem
    RLF	    ADAT1       ;vlt. Ha ez megtrtnik, s mg nem rkezett meg mind
    BCF	    ADAT4,0     ;a 32 bit, visszatr a ciklus elejre.
    BTFSS   PORTA,1
    BSF	    ADAT4,0
    BTFSS   PORTA,1
    GOTO    $-1
    DECFSZ  CIKLUS
    GOTO    VETEL  
    MOVLW   .112      ;--------------Adat ellen?rzs-------------
    SUBWF   ADAT1,F     ;Ha a vtel lezajlott, ellen?rzi a bejv? adatokat.
    BTFSS   STATUS,Z    ;Ha mind a 4 adat megfelelt, bekapcsolja a PWM
    GOTO    MAIN        ;kimenetet. Vgezetl bellt egy vrakozsi id?t.
    MOVLW   .25
    SUBWF   ADAT2,F
    BTFSS   STATUS,Z
    GOTO    MAIN
    MOVLW   .52
    SUBWF   ADAT3
    BTFSS   STATUS,Z
    GOTO    MAIN
    MOVLW   .250
    SUBWF   ADAT4
    BTFSS   STATUS,Z
    GOTO    MAIN    
    BSF	    PWM1CON,6    
    MOVLW   .250
    MOVWF   IDO
VARAKOZAS              ;---------------Biztonsgi vrakozs---------------
    CLRF    TMR0
    BCF	    INTCON,2
    BTFSS   INTCON,2
    GOTO    $-1
    BCF	    INTCON,2         ;Ez a kb. 4 msodperces vrakozs azrt van,
    DECFSZ  IDO              ;hogy megakadlyozza a vletlen tvornyt 
    GOTO    VARAKOZAS        ;nyomkods nem vrt hatst.
    MOVLW   .250
    MOVWF   IDO
VARAKOZAS2
    CLRF    TMR0
    BCF	    INTCON,2
    BTFSS   INTCON,2
    GOTO    $-1
    BCF	    INTCON,2
    DECFSZ  IDO
    GOTO    VARAKOZAS2    
MAIN2               ;-------------Kikapcsol jelre val vrakozs----------
    BCF	    INTCON,2    
    MOVLW   .32           ;Innent?l a program gyakorlatilag ismtl?dik.
    MOVWF   CIKLUS        ;annyi klmbsggel, hogy most a vett jel kikapcsolja
VETEL2                    ;a lmpt, illetve nem trl?dik a watchdog, teht 
    BTFSC   INTCON,2      ;ha lejr, reseteli a programot, azaz lekapcsol a
    GOTO    MAIN2         ;lmpa.
    BTFSC   PORTA,1
    GOTO    VETEL2  
    CLRF    TMR0
    BCF	    INTCON,2
    MOVLW   .16
    MOVWF   WAIT
    DECFSZ  WAIT
    GOTO    $-1
    RLF	    ADAT4
    RLF	    ADAT3
    RLF	    ADAT2
    RLF	    ADAT1
    BCF	    ADAT4,0
    BTFSS   PORTA,1
    BSF	    ADAT4,0
    BTFSS   PORTA,1
    GOTO    $-1
    DECFSZ  CIKLUS
    GOTO    VETEL2
    MOVLW   .112
    SUBWF   ADAT1,F
    BTFSS   STATUS,Z
    GOTO    MAIN2
    MOVLW   .25
    SUBWF   ADAT2,F
    BTFSS   STATUS,Z
    GOTO    MAIN2
    MOVLW   .52
    SUBWF   ADAT3
    BTFSS   STATUS,Z
    GOTO    MAIN2
    MOVLW   .250
    SUBWF   ADAT4
    BTFSS   STATUS,Z
    GOTO    MAIN2    
    BCF	    PWM1CON,6
    CLRF    LATA 
    MOVLW   .250
    MOVWF   IDO
VARAKOZAS3
    CLRF    TMR0
    BCF	    INTCON,2
    BTFSS   INTCON,2
    GOTO    $-1
    BCF	    INTCON,2
    DECFSZ  IDO
    GOTO    VARAKOZAS3
    MOVLW   .250
    MOVWF   IDO
VARAKOZAS4
    CLRF    TMR0
    BCF	    INTCON,2
    BTFSS   INTCON,2
    GOTO    $-1
    BCF	    INTCON,2
    DECFSZ  IDO
    GOTO    VARAKOZAS4     
    GOTO    MAIN
    END


